--- psqlodbc-09.01.0200/environ.c.old	2010-08-21 08:29:19.000000000 +0200
+++ psqlodbc-09.01.0200/environ.c	2012-09-09 08:37:38.055625304 +0200
@@ -194,8 +194,7 @@
 	CSTR func = "ER_ReturnError";
 	/* CC: return an error of a hstmt  */
 	PG_ErrorInfo	*error;
-	BOOL		partial_ok = ((flag & PODBC_ALLOW_PARTIAL_EXTRACT) != 0),
-			clear_str = ((flag & PODBC_ERROR_CLEAR) != 0);
+	BOOL		partial_ok = ((flag & PODBC_ALLOW_PARTIAL_EXTRACT) != 0);
 	const char	*msg;
 	SWORD		msglen, stapos, wrtlen, pcblen;
 
@@ -259,15 +258,9 @@
 		strncpy_null(szSqlState, error->sqlstate, 6);
 
 	mylog("	     szSqlState = '%s',len=%d, szError='%s'\n", szSqlState, pcblen, szErrorMsg);
-	if (clear_str)
-	{
-		error->errorpos = stapos + wrtlen;
-		if (error->errorpos >= msglen)
-		{
-			ER_Destructor(error);
-			*pgerror = NULL;
-		}
-	}
+
+	error->errorpos = stapos + wrtlen;
+
 	if (wrtlen == 0)
 		return SQL_SUCCESS_WITH_INFO;
 	else
@@ -482,7 +475,7 @@
 			SQLSMALLINT FAR * pcbErrorMsg)
 {
 	RETCODE	ret;
-	UWORD	flag = PODBC_ALLOW_PARTIAL_EXTRACT | PODBC_ERROR_CLEAR;
+	UWORD	flag = PODBC_ALLOW_PARTIAL_EXTRACT;
 
 	mylog("**** PGAPI_Error: henv=%p, hdbc=%p hstmt=%d\n", henv, hdbc, hstmt);
 
